# cwltool.workflow

## Classes

`Workflow` | Abstract CWL Process.
`WorkflowStep` | Abstract CWL Process.

## Functions

`default_make_tool`(toolpath_object, loadingContext) | Instantiate the given CWL Process.
`used_by_step`(step, shortinputid) |

## Module Contents

cwltool.workflow.default_make_tool(toolpath_object, loadingContext)

  Instantiate the given CWL Process.

  Parameters:

    - toolpath_object (ruamel.yaml.comments.CommentedMap)

    - loadingContext (cwltool.context.LoadingContext)

  Return type:

    cwltool.process.Process

class cwltool.workflow.Workflow(toolpath_object, loadingContext)

  Bases: `cwltool.process.Process`

  Abstract CWL Process.

  Parameters:

    - toolpath_object (ruamel.yaml.comments.CommentedMap)

    - loadingContext (cwltool.context.LoadingContext)

  steps: list[WorkflowStep] = []
  make_workflow_step(toolpath_object, pos, loadingContext)
    Parameters:

      - toolpath_object (ruamel.yaml.comments.CommentedMap)

      - pos (int)

      - loadingContext (cwltool.context.LoadingContext)

    Return type:

      WorkflowStep

  job(job_order, output_callbacks, runtimeContext)
    Parameters:

      - job_order (cwl_utils.types.CWLObjectType)

      - output_callbacks (cwltool.utils.OutputCallbackType)

      - runtimeContext (cwltool.context.RuntimeContext)

    Return type:

      cwltool.utils.JobsGeneratorType

  visit(op)
    Parameters:

      op (collections.abc.Callable[[ruamel.yaml.comments.CommentedMap], None])

    Return type:

      None

cwltool.workflow.used_by_step(step, shortinputid)
  Parameters:

    - step (cwltool.utils.StepType)

    - shortinputid (str)

  Return type:

    bool

class cwltool.workflow.WorkflowStep(toolpath_object, pos, loadingContext)

  Bases: `cwltool.process.Process`

  Abstract CWL Process.

  Parameters:

    - toolpath_object (ruamel.yaml.comments.CommentedMap)

    - pos (int)

    - loadingContext (cwltool.context.LoadingContext)

  receive_output(output_callback, jobout, processStatus)
    Parameters:

      - output_callback (cwltool.utils.OutputCallbackType)

      - jobout (cwl_utils.types.CWLObjectType)

      - processStatus (str)

    Return type:

      None

  job(job_order, output_callbacks, runtimeContext)

    Initialize sub-workflow as a step in the parent profile.

    Parameters:

      - job_order (cwl_utils.types.CWLObjectType)

      - output_callbacks (cwltool.utils.OutputCallbackType)

      - runtimeContext (cwltool.context.RuntimeContext)

    Return type:

      cwltool.utils.JobsGeneratorType

  visit(op)
    Parameters:

      op (collections.abc.Callable[[ruamel.yaml.comments.CommentedMap], None])

    Return type:

      None